<!DOCTYPE html>
<html lang="es">

<!--
      AUTOR: DIEGO SANCHEZ SANCHEZ

      * Gitlab: https://gitlab.com/dawlugo/apps/lmsx/travel-app

      ***IMPORTANTE: 
        debe ser ejecutado en un servidor web o no funcionarán
        los componentes

      Para este proyecto sólo se ha utilizado javascript para generar
      el contenido dinámico cogiéndolos de un un mapa de objetos
      y se han creado usuarios ficticios que se guardan en el almacenamiento
      local del navegador por consistencia.

      Además se ha simulado la interación con el servidor utilizando javascript
      para no tener que crear varias paginas con código repetido, usando
      la url de la página y plantillas (templates)

      Se han utilizado componentes creados por mí, para los elementos repetitivos
      entre varias páginas. Ya que si los repites corres el riesgo de actualizar
      en un sitio y no en el resto además todo queda más centralizado

      La estructura de las carpetas aunque podía ser mejor he decidido ya que
      el proyecto es pequeño poner las paginas globales en el raíz, y los css
      del mismo bajo la carpeta de css dividido por componentes. En proyectos
      grandes es recomedable poner los puntos de entrada solo en el raíz y luego
      hacer carpetas para las paginas, componentes, etc y agrupar los css y js

      En las clases he decidido usar la nomenclatura de pascalcase,
      y usar la separacion con guiones para los
      componentes y elementos, simulando que es otro elemento más de html
      pero al ser una componente propio se ve mejor así

      He decidio usar identificadores únicos en los elementos que no quiero
      que se repitan en la página, para que me de error si los incluyo varias
      veces pero perfectamente se podrían usar clases

      Los enlaces, link y script contienen rutas relativas a las páginas que están
      en el raíz o a sus propios componentes que tienen su propia carpeta

      Pero para la navegación principal, es decir el nav-bar(routing),
      y ciertos elementos que se encuentran aniddos en subcarpetas,  he decidido
      utilizar absolutas con respecto al servidor debido a que así siempre van
      a encontrar la manera de coger los recursos o acceder a ellos aunque
      cambiases su ubicación (no la de los recursos)

      Cuando utilizo componentes y templates, agrego el javascript más o menos
      en la ubicación donde les corresponde, clonando o creando el nodo

      Si lo que quiero es cambiar un contenido de un nodo creado lo que hago
      es dentro del mismo ubico el javascript para que no haya una rotura entre
      el diseño y estructura de la página y donde irían los datos que en vez
      de ser estáticos son dinámicos

      Los ids los pongo en mínusculas porque sólo puede haber uno, aunque el
      componente vaya en mayúsculas, porque igual en un futuro lo pongo en
      pascalcase o uso clases en vez de ids

      La decisión de si una imagen la pongo de background con css o con
      img radica en la utilización e indexación. Es decir si esa imagen
      es decorativa y no parece usarse para poder descargar o aporta
      algo a la información de la página lo dejaré con background que
      encima es más fácil de maquetar. Si es una imagen con información
      que encima va a tener un atributo alt para dar información a la
      accesibilidad y los buscadores pondré un img

      Cabe resaltar que realmente se suele utilizar ahora el enfoque de que todo
      sean componentes, y muchos elementos podrían haber sido empaquetados
      como tales para su reulización pero como es realmente un ejercicio
      que se centra más en el css he decidido mostrar varias maneras de hacerlo

  -->

<head>
  <meta charset="UTF-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lugares</title>
  <!-- pongo primero los componentes antes que la página -->
  <link rel="stylesheet" href="components/Info/Info.css" />
  <link rel="stylesheet" href="components/App-Bar/App-Bar.css" />
  <link rel="stylesheet" href="components/Config/Config.css" />
  <link rel="stylesheet" href="components/Nav-Bar/Nav-Bar.css" />
  <link rel="stylesheet" href="css/filter.css" />
  <link rel="stylesheet" href="css/travel_place.css" />
  <link rel="stylesheet" href="css/index.css" />
  <!-- primero van las utilidades que usarán el resto de scripts -->
  <script src="scripts/utils.js"></script>
  <script src="scripts/users.js"></script>
  <script src="scripts/places.js"></script>
</head>

<body>
  <header>
    <!--
            Se inserta la barra de aplicación [app-bar] que es comun
            en varias páginas
            Además se cambia dinámicamente el título de app-bar
            *** Aquí sustituimos todo el contenido si lo hubiera del header
        -->
    <script type="module">
      import { AppBar } from "./components/App-Bar/App-Bar.js";
      $("header")
        .innerHTML = AppBar;
      $("#app-bar .Title")
        .textContent = "LUGARES";
    </script>
  </header>
  <!--
        Vamos a agregar un menu de configuración a la pagina que usará
        poscionamiento absoluto por eso agregamos un nuevo elemento div a la
         página al final del body y usamos outerhtml para sustituir
         el elemento por el nuestro
     -->
  <script type="module">
    import { Config } from "./components/Config/Config.js";
    var configElement = document.createElement("div");
    $("body").appendChild(configElement);
    configElement.outerHTML = Config;
  </script>
  <section id="subheader">
    <!--
            Esto es el selector que sirve para filtrar los lugares
            según los tengas o no agregados a tus favoritos
            Al llevar el mismo nombre sólo uno podrá ser seleccionado a la vez
            el label lo vamos a usar para poder seleccionar todo el boton
         -->
    <div id="filter">
      <label for="filterall">
        <input id="filterall"
          type="radio" name="filterState" value="All" checked />
        <div class="Text">Todos</div>
      </label>
      <label for="filterfavorite">
        <input id="filterfavorite"
          type="radio" name="filterState" value="Favorite" />
        <div class="Text">Favs</div>
      </label>
      <label for="filterunfavorite">
        <input id="filterunfavorite"
          type="radio" name="filterState" value="Unfavorite" />
        <div class="Text">Nope</div>
      </label>
    </div>
  </section>
  <nav>
    <!--
            Se inserta la barra de navegación [nav-bar] que es
            comun en varias páginas
            Además se agrega una clase en el elemento que nos permitirá
            saber si este elemento debe estar seleccionado o no al cargar
            la susodicha página
        -->
    <script type="module">
      import { NavBar } from "./components/Nav-Bar/Nav-Bar.js";
      $("nav").innerHTML = NavBar;
      $("#home").classList.add("Selected");
    </script>
  </nav>
  <main>
    <div id="cards">
      <!--
                Aquí vamos a usar una plantilla, esto podría ser un componente
                externo, pero como lo usamos sólo en esta página, podemos
                simplemente usarla aquí con la ventaja de que se puede ver
                y manipular el código html directamente como si estuvieras
                haciendo html estático, al menos para interactuar
                con la estructura

                Es cierto que tengo una clase Top que aparentemente en esta
                tarjeta no se va a usar pero puede que en un futuro sí

                Destacar el uso de una variable --value a la que le asignamos
                un valor, este valor se calcula de las reseñas de los lugares
                y se le pasa al css para que haga calculos y se visualicen
                las estrellas correctamente (se podría haber usado también
                javascript pero intenté usar css en todo lo que pude)
            -->
      <template id="tmpTravelPlace">
        <a href="reviews.html?id=machu-picchu" class="TravelPlace">
          <div class="Top"></div>
          <div class="Bottom">
            <div class="Left">
              <div class="Title">machu picchu</div>
              <div class="Rating">
                <div class="RatingBar" style="--value: 7.5"></div>
                <div class="Value">7.77</div>
              </div>
              <div class="Location">
                <div class="City"></div>
                <div class="Country"></div>
              </div>
            </div>
            <div class="Right">
              <div class="IconButton"></div>
            </div>
          </div>
        </a>
      </template>
      <!--
                Vamos a cargar las plantillas con datos dinámicamente
            -->
      <script>
        // Iterar sobre el mapa y generar contenido dinámico
        places.forEach(function (travel, clave) {
          // Clonar la plantilla
          const travelPlace = $("#tmpTravelPlace")
            .content.cloneNode(true);

          travelPlace.querySelector(".TravelPlace")
            .id = clave;
          travelPlace.querySelector("a")
            .href = `reviews.html?id=${clave}`;
          travelPlace.querySelector(".TravelPlace")
            .style.backgroundImage = `url(images/photos/${travel.image})`;
          travelPlace.querySelector(".Title")
            .textContent = travel.title;
          travelPlace.querySelector(".Rating .RatingBar")
            .style.setProperty("--value", travel.rating);
          travelPlace.querySelector(".Rating .Value")
            .textContent = travel.rating;
          travelPlace.querySelector(".Location .City")
            .textContent = travel.location.city;
          travelPlace.querySelector(".Location .Country")
            .textContent = travel.location.country;
          //a la hora de saber si un lugar está agregado a favoritos
          // le pondremos una clase u otra y usamos css para
          // visualizar el background correcto, se podría haber
          // usado el style pero también la vamos a necesitar
          // para hacer el filtrado por css con el filter
          if (travel.isFavorite) {
            travelPlace.querySelector(".IconButton")
              .classList.add("HeartFilled");
            travelPlace.querySelector(".TravelPlace")
              .classList.add("All", "Favorite");
          } else {
            travelPlace.querySelector(".IconButton")
              .classList.add("HeartOutlined");
            travelPlace.querySelector(".TravelPlace")
              .classList.add("All", "Unfavorite");
          }
          // Agregar el nuevo elemento al contenedor
          $("#cards").appendChild(travelPlace);
        });
      </script>
    </div>
  </main>
  <footer>
    <script type="module">
      import { Info } from "./components/Info/Info.js";
      $("footer").innerHTML = Info;
    </script>
  </footer>
</body>

</html>